#!/bin/bash
# originally by Iguleder
# hacked to DEATH by 01micko
# re-hacked by stemsee to provide unattended version, which auto-builds 
# 64bit, 32bit-nopae then 32bit-pae kernels and modules consecutively.
# And renames /dist/packages to packages64, packages32-pae and packages32-nopae
# see /usr/share/doc/legal NO WARRANTY, NO responsibility accepted
AppVersion="0.3"
old=`cat build64.conf | grep -e 'kernel_version=' | cut -f2 -d '"'`
olsfix=`cat build64.conf | grep -e 'custom_suffix=' | cut -f2 -d '-'`
olfsv=`cat build64.conf | grep -e 'aufsv=' | rev | cut -f1 -d '=' | rev`
CWD=`pwd`
timelimit=8
tmstamp=`date | cut -f1,2,4,5,7 -d ' ' | tr ' ' '-' | cut -f1,2 -d ':'`
# get today's date
today=`date +%d%m%y`
#fakeroot make-kpkg --initrd --revision=custom.1.0 kernel_image
echo "Please enter which kernel arch to build

e.g.    1) 64bit
        2) 32bit-nopae
        3) 32bit-pae
        
e.g.   '1'  or  '2'  or  '3'  or  '12' or '23' or '13' or '123' 
	
	for debian system packages add deb
		e.g. '1 deb' '123 deb' 
(MAKE SURE 'kernel-package' AND 'fakeroot' ARE INSTALLED for debian pkg)"

read arch DEB
if [ -z "$arch" ]; then
arch="123"
fi
echo "'$arch'"



if [[ -d dist/packages ]]; then
mkdir -p dist/previouspkgs-$tmstamp
mv -f dist/package* dist/previouspkgs-$tmstamp
fi

echo "If you wish to compile an old version kernel then at 'config menu' select
            option '2. make menuconfig'

Please now enter the kernel version you would like this script to compile.
Present set version is '$old' 
e.g.    3.18.5"
read latest

if [ -z "$latest" ]; then
latest="$old"
fi
echo "'$latest'"
sed -i "s/$old/$latest/" build64.conf
#echo "1"
sed -i "s/$old/$latest/" build32-pae.conf
#echo "2"
sed -i "s/$old/$latest/" build32-nopae.conf
#echo "3"
nafsv=`echo $latest | cut -f1,2 -d '.'`
sed -i 35d build64.conf
sed -i 35i\ aufsv="$nafsv" build64.conf
#echo "4"
sed -i 35d  build32-pae.conf
sed -i 35i\ aufsv="$nafsv" build32-pae.conf
#echo "5"
sed -i 35d  build32-nopae.conf
sed -i 35i\ aufsv="$nafsv" build32-nopae.conf
#echo "6"
echo

echo "You can change the custom name on the kernel. Better not use minus symbol -.
Presently it is '$olsfix'. For debian system must be lowercase."
read nwsfix

if [ -z "$nwsfix" ]; then
nwsfix="$olsfix"
fi
echo "'$nwsfix'"
sed -i "s/$olsfix/$nwsfix/" build64.conf

sed -i "s/$olsfix/$nwsfix/" build32-pae.conf

sed -i "s/$olsfix/$nwsfix/" build32-nopae.conf
echo
echo
bldkern1 () {
. build64.conf

echo
echo
if [ "$1" = "" ];then
	echo -en "\033[1;35m""WARNING" #purple?
	echo -en "\033[0m" #reset
	echo ": This will delete aufs, kernel folder but wont touch configs or dist."
	sleep 2
	echo "Please wait..."
	rm -rf ./{aufs*,linux*,kernel*,build.log*}
	rm -f dist/sources/build.log.bz2 && rm -f dist/sources/DOTconfig*
	echo "Cleaning complete"
fi
if [[ -d ./aufs* ]];then
	echo "This is not a clean kit."
	echo " CTRL+C to quit"
	read notcleango
fi

FW_URL=${FW_URL:-http://distro.ibiblio.org/puppylinux/firmware}
package_name_suffix=$package_name_suffix
custom_suffix=$custom_suffix
kernel_version=$kernel_version
kernel_mirror=$kernel_mirror
echo
# depcheck
echo "Dependency check..."
if [ ! -z "$DEB" ]; then
if fakeroot --version &>/dev/null
	then echo -e "\033[1;32m""fakeroot is installed" #green 
else echo -e "\033[1;31m""fakeroot might not be installed""\033[0m" #red
fi
fi
if git --version &>/dev/null
	then echo -e "\033[1;32m""git is installed" #green 
else echo -e "\033[1;31m""git is not installed""\033[0m" && exit #red
fi
if gcc --version &>/dev/null
	then echo -e "\033[1;32m""gcc is installed" 
else
   echo -e "\033[1;31m""gcc is not installed""\033[0m" && exit
fi
MKSQ="$(which mksquashfs)"
if [ "$MKSQ" ]
	then 
   echo -e "\033[1;32m""mksquashfs is installed"
else #yellow
   echo -e "\033[1;30m""mksquashfs is not installed but you can continue"
fi
echo -e "\033[0m" #reset to original

# .configs
[ -f /tmp/kernel_configs ] && rm -f /tmp/kernel_configs

CONFIGS=$(ls ./configs_extra)

# list
echo "configs"
NUM=1
for C in $CONFIGS
  do echo "${NUM}. $C" >> /tmp/kernel_configs
  NUM=$(($NUM + 1))
  done
#echo "z. Custom DOTconfig" >> /tmp/kernel_configs
#echo "d. Default DOTconfig" >> /tmp/kernel_configs  

# delete the previous log
[ -f build.log ] && rm -f build.log
[ -f build.log.tar.bz2 ] && mv -f build.log-tmstamp.tar.bz2

# the aufs major version
aufs_version=${kernel_version%%.*}
# get the major version (2.6.32 in the case of 2.6.32.40)
kernel_major_version=$kernel_version #blah, hack for 3.x
# get the kernel branch (32 in the case of 2.6.32.40; needed to download Aufs)
kernel_branch=`echo $kernel_major_version | cut -f 2 -d .` #3.x kernels

# create directories for the results
[ ! -d dist/sources/vanilla ] && mkdir -p dist/sources/{patches,vanilla}



# delete the previous log
[ -f build.log ] && rm -f build.log
[ -f build.log.tar.bz2 ] && mv -f build.log.tar.bz2

#downkern () {

if [ ! -f dist/sources/vanilla/linux-$kernel_version.tar.xz ]; then
# download the kernel
echo ${kernel_version##*-}|grep -q "rc"
[ "$?" -eq 0 ] && testing=testing||testing=
	if [[ ! -f dist/sources/vanilla/linux-$kernel_version.tar.xz ]]; then
	echo "Downloading the kernel sources"
	wget -P dist/sources/vanilla $kernel_mirror/$testing/linux-$kernel_version.tar.xz --no-check-certificate > build.log 2>&1
		if [[ $? -ne 0 ]]; then
			echo "Error: failed to download the kernel sources."
			exit 1
		fi
	fi

elif [ -f dist/sources/vanilla/linux-$kernel_version.tar.xz ]; then
echo "Kernel Sources already there!"
fi
#}

#downkern

#downaufs () {
	# download Aufs
#if [ ! -f dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2 ]; then

		git clone git://git.code.sf.net/p/aufs/aufs3-standalone aufs$aufs_version-18-git$today >> build.log 2>&1

		if [[ $? -ne 0 ]]; then
			echo "Error: failed to download the Aufs sources."
			exit 1
		fi
		cd aufs$aufs_version-$kernel_branch-git$today
		if [[ "$aufsv" ]];then #new far for new kernels
		git checkout origin/aufs$aufsv >> ../build.log 2>&1
		else
		git checkout origin/aufs$aufs_version.$kernel_branch >> ../build.log 2>&1
		fi
		if [[ $? -ne 0 ]]; then
		echo "Error: failed to download the Aufs sources."
		exit 1
		fi
	rm -rf .git
	cd ..
	echo "Creating the Aufs sources tarball"
	tar -c aufs$aufs_version-$kernel_branch-git$today | bzip2 -9 > dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2

	echo "Extracting the Aufs sources"
	tar xf dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to extract the Aufs sources."
		exit 1
		fi
#}
#downaufs

#patchaufs () {
	# patch Aufs
if [ -f aufs-allow-sfs.patch ];then #removed for K3.9 experiment
	echo "Patching the Aufs sources"
	patch -d aufs$aufs_version-$kernel_branch-git$today -p1 < aufs-allow-sfs.patch >> build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to patch the Aufs sources."
		exit 1
	fi
	cp aufs-allow-sfs.patch dist/sources/patches
fi
if [ -f aufs-kconfig.patch ];then #special for K3.9
	echo "Patching the Aufs sources"
	patch -d aufs$aufs_version-$kernel_branch-git$today -p1 < aufs-kconfig.patch >> build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to patch the Aufs sources for kconfig."
		exit 1
	fi
	cp aufs-kconfig.patch dist/sources/patches
fi
#}
#patchaufs

#extractkern () {
	# extract the kernel
echo "Extracting the kernel sources"
tar xf dist/sources/vanilla/linux-$kernel_version.tar.* >> build.log 2>&1
if [[ $? -ne 0 ]]; then
	echo "Error: failed to extract the kernel sources."
	exit 1
	extractkern
else
echo "extracted"
fi
#}
#extractkern

cd linux-$kernel_version

#aufspatch () {
	echo "Adding Aufs to the kernel sources"
for i in kbuild base standalone mmap; do
	patch -N -p1 < ../aufs$aufs_version-$kernel_branch-git$today/aufs$aufs_version-$i.patch >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "WARNING: failed to add some Aufs patches to the kernel sources."
		echo "Check it manually and either CRTL+C to bail or hit enter to go on"
		sleep 4
	fi
done
#}
#aufspatch

cp -r ../aufs$aufs_version-$kernel_branch-git$today/{fs,Documentation} .
cp ../aufs$aufs_version-$kernel_branch-git$today/include/linux/aufs_type.h include/linux 2>/dev/null
cp ../aufs$aufs_version-$kernel_branch-git$today/include/uapi/linux/aufs_type.h include/linux 2>/dev/null
[ -d ../aufs$aufs_version-$kernel_branch-git$today/include/uapi ] && \
cp -r ../aufs$aufs_version-$kernel_branch-git$today/include/uapi/linux/aufs_type.h include/uapi/linux

echo "Resetting the minor version number"
cp Makefile Makefile-orig
sed -i "s/^EXTRAVERSION =/EXTRAVERSION = $custom_suffix/" Makefile
diff -up Makefile-orig Makefile > ../dist/sources/patches/extra-version.patch
rm Makefile-orig

#echo "Reducing the number of consoles"
#if [ "$kernel_branch" -ge 12 ]; then
 #if [[ "${kernel_version%%.*}" -ge 3 -a "$kernel_branch" -ge 16 ]]; then
	 cp kernel/printk/printk.c kernel/printk/printk.c.orig
	 sed -i s/'#define MAX_CMDLINECONSOLES 8'/'#define MAX_CMDLINECONSOLES 5'/ kernel/printk/printk.c
	 diff -up kernel/printk/printk.c.orig kernel/printk/printk.c > ../dist/sources/patches/less-consoles.patch
	
	 echo "Reducing the verbosity level"
	 cp -f include/linux/printk.h include/linux/printk.h.orig
	 sed -i s/'#define CONSOLE_LOGLEVEL_DEFAULT 7 \/\* anything MORE serious than KERN_DEBUG \*\/'/'#define CONSOLE_LOGLEVEL_DEFAULT 3 \/\* anything MORE serious than KERN_ERR \*\/'/ include/linux/printk.h
	 diff -up include/linux/printk.h.orig include/linux/printk.h > ../dist/sources/patches/lower-verbosity.patch


#patches () {
for patch in ../patches/*; do
	echo "Applying $patch"
	patch -p1 < $patch >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to apply $patch on the kernel sources."
		exit 1
	fi
	cp $patch ../dist/sources/patches

done
#}
#patches

#cleaningsrc () {
echo "Cleaning the kernel sources"
if [[ -z "$DEB" ]]; then
make clean
make mrproper
else
make-kpkg clean
fi
find . -name '*.orig' -delete
find . -name '*.rej' -delete
find . -name '*~' -delete

figs=`cat /tmp/kernel_configs`
echo "$figs"
sleep 2

Chosen=1

echo "$Chosen"
sleep 1
Choice=$(grep "^$Chosen\." /tmp/kernel_configs | cut -d ' ' -f2)
echo "$Choice"
sleep 1
[[ DOTconfig ]] && rm -r DOTconfig
cp -af configs_extra/$Choice DOTconfig
 
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/i386_defconfig
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/x86_64_defconfig
#pause to configure
#configure () {
clear
echo -e "For unattended config of new kernels do nothing here!
For old kernel versions or other customisations enter 2 ... 

1. make olddefconfig
2. make menuconfig 
$timelimit seconds\n: \c"
echo
read -t $timelimit kernelconfig
if [ ! -z "$kernelconfig" ]; then
echo -e "\n You entered '$kernelconfig'"
else
echo -e "\n TIME OUT\n Assume default."
kernelconfig=1
fi

case $kernelconfig in
1) make olddefconfig;;
2) make menuconfig;;
esac

echo
echo "Ok, kernel is configured. CTRL+C to quit"
sleep 2
if [  "$kernelconfig" = 1 ]; then
cp -f ../DOTconfig .config.old
cp -f ../DOTconfig .config
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/i386_defconfig
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/x86_64_defconfig
fi

[ ! -d ../dist/packages ] && mkdir -p ../dist/packages
#}
#configure

#krnheads () {
	echo "Creating the kernel headers package"
make headers_check >> ../build.log 2>&1
make INSTALL_HDR_PATH=kernel_headers-$kernel_major_version-$package_name_suffix/usr headers_install >> ../build.log 2>&1
find kernel_headers-$kernel_major_version-$package_name_suffix/usr/include \( -name .install -o -name ..install.cmd \) -delete
mv kernel_headers-$kernel_major_version-$package_name_suffix ../dist/packages
#}
#krnheads

#krncompile () {
echo "Compiling the kernel"
cores=`cat /proc/cpuinfo | grep 'cpu cores' | cut -f3 -d ' ' | tr '\n' ' ' | cut -f1 -d ' '`
if [ "$cores" -ge 2 ]; then
	if [[ -z "$DEB" ]]; then
	make -j6
	elif [[ ! -z "$DEB" ]]; then
	fakeroot make-kpkg --initrd --revision=custom.emsee-$tmstamp kernel_image -j6
	fi
else
	if [[ -z "$DEB" ]]; then
	make
	elif [[ ! -z "$DEB" ]]; then
	fakeroot make-kpkg --initrd --revision=custom.emsee-$tmstamp kernel_image
	fi
fi
if [[ ! -f arch/x86/boot/bzImage || ! -f System.map ]]; then
	echo "Error: failed to compile the kernel sources."
	exit 1
fi
cp .config ../dist/sources/DOTconfig-$kernel_version-$tmstamp

#}

#krncompile
echo "Creating the kernel package"
make INSTALL_MOD_PATH=linux_kernel-$kernel_major_version-$package_name_suffix modules_install >> ../build.log 2>&1
rm -f linux_kernel-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/{build,source}
mkdir -p linux_kernel-$kernel_major_version-$package_name_suffix/boot
mkdir -p linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules
cp .config linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules/DOTconfig-$kernel_version-
cp arch/x86/boot/bzImage linux_kernel-$kernel_major_version-$package_name_suffix/boot/vmlinuz
BZIMAGE=`find . -type f -name bzImage`
cp System.map linux_kernel-$kernel_major_version-$package_name_suffix/boot/
cp linux_kernel-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/{modules.builtin,modules.order} \
 linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules/
mv linux_kernel-$kernel_major_version-$package_name_suffix ../dist/packages/
if [ "$FD" = "1" ];then #make fatdog kernel module package
	mv ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/vmlinuz ../dist/packages/vmlinuz
	[ -f ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/bzImage ] &&
rm -f ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/bzImage
	echo "Huge kernel $kernel_major_version-$package_name_suffix is ready in dist"
fi

echo "Cleaning the kernel sources"
make clean >> ../build.log 2>&1
make prepare >> ../build.log 2>&1

cd ..

# build aufs-utils userspace modules
echo "Now to build the aufs-utils for userspace"
if [ ! -f dist/sources/vanilla/aufs-util${today}.tar.bz2 ];then
	git clone git://aufs.git.sourceforge.net/gitroot/aufs/aufs-util.git aufs-util >> build.log 2>&1
	[[ $? -ne 0 ]] && echo "Failed to get aufs-util from git, do it manually. Kernel is compiled OK :)" && exit
	
	cd aufs-util
	
	git branch -a | grep 'aufs3' |grep -v 'rcN' | cut -d '.' -f2 > /tmp/aufs-util-version #we go for stable only
	while read line
	  do 
	    if [[ "$kernel_branch" = "$line" ]];then branch=$line
	    else
	      while [[ "$kernel_branch" -gt "$line" ]]
	        do branch=$line
	        echo $branch && break
	        done 
	    fi
	  done < /tmp/aufs-util-version
	git checkout origin/aufs3.${branch} >> ../build.log 2>&1
	
	[[ $? -ne 0 ]] && echo "Failed to get aufs-util from git, do it manually. Kernel is compiled OK :)" && exit
	echo "Patching aufs-util sources"
	cp Makefile Makefile.orig
	sed -i 's/-static //' Makefile
	diff -ru Makefile.orig Makefile > ../dist/sources/patches/aufs-util-dynamic.patch
	rm *.orig
	else
	echo "Extracting the Aufs-util sources"
	tar xf dist/sources/vanilla/aufs-util$today.tar.bz2 >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to extract the aufs-util sources."
		exit 1
	fi	
	cd aufs-util	
	patch -p1 < ../dist/sources/patches/aufs-util-dynamic.patch >> ../build.log 2>&1
	[[ "$?" -ne 0 ]] && echo "Failed to patch the aufs-util sources, do it manually. Kernel is compiled ok"
fi
arch=`uname -m`
CONFIG=`find $CWD/dist/sources -type f -name 'DOTconfig*'`
grep -q 'CONFIG_AUFS_FHSM=y' $CONFIG
[[ "$?" -eq 0 ]] && export MAKE=make || export MAKE="make BuildFHSM=no"
LinuxSrc=`find $CWD -type d -name 'kernel_headers*'`
export CPPFLAGS="-I $LinuxSrc/usr/include"
$MAKE >> ../build.log 2>&1
[[ $? -ne 0 ]] && echo "Failed to compile aufs-util, do it manually. Kernel is compiled OK :)"
make DESTDIR=$CWD/dist/packages/aufs-util-$kernel_version-$arch install >> ../build.log 2>&1 #maybe needs absolute path
make clean >> ../build.log 2>&1
if [[ "$arch" = "x86_64" ]];then
 mv $CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib \
$CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib64
fi
echo "aufs-util-$kernel_version is in dist"
cd ..
if [[ "$FD" = "1" ]];then #shift aufs-utils to kernel-modules.sfs
	echo "Installing aufs-utils into kernel package"
	cp -a dist/packages/aufs-util-$kernel_version-$arch/* \
	dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix
	cp -r /lib/firmware dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/lib/
	mksquashfs dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix dist/packages/kernel-modules-$kernel_major_version-$package_name_suffix.sfs $COMP

fi

tar -c aufs-util | bzip2 -9 > dist/sources/vanilla/aufs-util$today-$-$arch.tar.bz2

echo "Done!"

rename packages packages64 dist/packages

[ -f /usr/share/sounds/2barks.au ] && aplay /usr/share/sounds/2barks.au

}

mkkernsrc () {
	echo "Creating a kernel sources SFS"
mkdir -p kernel_sources-$kernel_major_version-$package_name_suffix/usr/src
mv linux-$kernel_version kernel_sources-$kernel_major_version-$package_name_suffix/usr/src/linux
mkdir -p kernel_sources-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix
ln -s /usr/src/linux kernel_sources-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/build
[ ! -f kernel_sources-${kernel_major_version}-$package_name_suffix/usr/src/linux/include/linux/version.h ] && \
ln -s /usr/src/linux/include/generated/uapi/linux/version.h kernel_sources-${kernel_major_version}-$package_name_suffix/usr/src/linux/include/linux/version.h 
ln -s /usr/src/linux kernel_sources-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/source
mksquashfs kernel_sources-$kernel_major_version-$package_name_suffix dist/sources/kernel_sources-$kernel_major_version-$package_name_suffix.sfs $COMP
}

bldkern2 () {
#SECOND RUN
. build32-nopae.conf

if [ "$1" = "" ];then
	echo -en "\033[1;35m""WARNING" #purple?
	echo -en "\033[0m" #reset
	echo ": This will delete aufs, kernel folder but wont touch configs or dist."
	sleep 2
	echo "Please wait..."
	rm -rf ./{aufs*,build.log*}
	echo "Cleaning complete"
fi
if [[ -d ./aufs* ]];then
	echo "This is not a clean kit."
	echo " CTRL+C to quit"
	read notcleango
fi

FW_URL=${FW_URL:-http://distro.ibiblio.org/puppylinux/firmware}
package_name_suffix=$package_name_suffix
custom_suffix=$custom_suffix
kernel_version=$kernel_version
kernel_mirror=$kernel_mirror

# the aufs major version
aufs_version=${kernel_version%%.*}
# get the major version (2.6.32 in the case of 2.6.32.40)
kernel_major_version=$kernel_version #blah, hack for 3.x
# get the kernel branch (32 in the case of 2.6.32.40; needed to download Aufs)
kernel_branch=`echo $kernel_major_version | cut -f 2 -d .` #3.x kernels

# create directories for the results
[ ! -d dist/sources/vanilla ] && mkdir -p dist/sources/{patches,vanilla}

# .configs
[ -f /tmp/kernel_configs ] && rm -f /tmp/kernel_configs

CONFIGS=$(ls ./configs_extra)

# list
echo "configs"
NUM=1
for C in $CONFIGS
  do echo "${NUM}. $C" >> /tmp/kernel_configs
  NUM=$(($NUM + 1))
  done
#echo "z. Custom DOTconfig" >> /tmp/kernel_configs
#echo "d. Default DOTconfig" >> /tmp/kernel_configs  
figs=`cat /tmp/kernel_configs`
echo "$figs"
sleep 2

Chosen=2

echo "$Chosen"
sleep 1
Choice=$(grep "^$Chosen\." /tmp/kernel_configs | cut -d ' ' -f2)
echo "$Choice"
sleep 1
[[ DOTconfig ]] && rm -r DOTconfig
cp -af configs_extra/$Choice DOTconfig
if [ ! -f dist/sources/vanilla/linux-$kernel_version.tar.xz ]; then
# download the kernel
echo ${kernel_version##*-}|grep -q "rc"
[ "$?" -eq 0 ] && testing=testing||testing=
	if [[ ! -f dist/sources/vanilla/linux-$kernel_version.tar.xz ]]; then
	echo "Downloading the kernel sources"
	wget -P dist/sources/vanilla $kernel_mirror/$testing/linux-$kernel_version.tar.xz --no-check-certificate > build.log 2>&1
		if [[ $? -ne 0 ]]; then
			echo "Error: failed to download the kernel sources."
			exit 1
		fi
	fi

elif [ -f dist/sources/vanilla/linux-$kernel_version.tar.xz ]; then
echo "Kernel Sources already there!"
fi
#}

#downkern

#downaufs () {
	# download Aufs
#if [ ! -f dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2 ]; then

		git clone git://git.code.sf.net/p/aufs/aufs3-standalone aufs$aufs_version-18-git$today >> build.log 2>&1

		if [[ $? -ne 0 ]]; then
			echo "Error: failed to download the Aufs sources."
			exit 1
		fi
#fi
		cd aufs$aufs_version-$kernel_branch-git$today
		if [[ "$aufsv" ]];then #new far for new kernels
		git checkout origin/aufs$aufsv >> ../build.log 2>&1
		else
		git checkout origin/aufs$aufs_version.$kernel_branch >> ../build.log 2>&1
		fi
		if [[ $? -ne 0 ]]; then
		echo "Error: failed to download the Aufs sources."
		exit 1
		fi
	rm -rf .git
	cd ..
	echo "Creating the Aufs sources tarball"
	tar -c aufs$aufs_version-$kernel_branch-git$today | bzip2 -9 > dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2

	echo "Extracting the Aufs sources"
	tar xf dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to extract the Aufs sources."
		exit 1
		fi
#}
#downaufs

#patchaufs () {
	# patch Aufs
if [ -f aufs-allow-sfs.patch ];then #removed for K3.9 experiment
	echo "Patching the Aufs sources"
	patch -d aufs$aufs_version-$kernel_branch-git$today -p1 < aufs-allow-sfs.patch >> build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to patch the Aufs sources."
		exit 1
	fi
	cp aufs-allow-sfs.patch dist/sources/patches
fi
if [ -f aufs-kconfig.patch ];then #special for K3.9
	echo "Patching the Aufs sources"
	patch -d aufs$aufs_version-$kernel_branch-git$today -p1 < aufs-kconfig.patch >> build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to patch the Aufs sources for kconfig."
		exit 1
	fi
	cp aufs-kconfig.patch dist/sources/patches
fi
#}
#patchaufs

#extractkern () {
	# extract the kernel
echo "Extracting the kernel sources"
tar xf dist/sources/vanilla/linux-$kernel_version.tar.* >> build.log 2>&1
if [[ $? -ne 0 ]]; then
	echo "Error: failed to extract the kernel sources."
	exit 1
	extractkern
else
echo "extracted"
fi
#}
#extractkern

cd linux-$kernel_version

#aufspatch () {
	echo "Adding Aufs to the kernel sources"
for i in kbuild base standalone mmap; do
	patch -N -p1 < ../aufs$aufs_version-$kernel_branch-git$today/aufs$aufs_version-$i.patch >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "WARNING: failed to add some Aufs patches to the kernel sources."
		echo "Check it manually and either CRTL+C to bail or hit enter to go on"
		sleep 4
	fi
done
#}
#aufspatch

cp -r ../aufs$aufs_version-$kernel_branch-git$today/{fs,Documentation} .
cp ../aufs$aufs_version-$kernel_branch-git$today/include/linux/aufs_type.h include/linux 2>/dev/null
cp ../aufs$aufs_version-$kernel_branch-git$today/include/uapi/linux/aufs_type.h include/linux 2>/dev/null
[ -d ../aufs$aufs_version-$kernel_branch-git$today/include/uapi ] && \
cp -r ../aufs$aufs_version-$kernel_branch-git$today/include/uapi/linux/aufs_type.h include/uapi/linux

echo "Resetting the minor version number"
cp Makefile Makefile-orig
sed -i "s/^EXTRAVERSION =/EXTRAVERSION = $custom_suffix/" Makefile
diff -up Makefile-orig Makefile > ../dist/sources/patches/extra-version.patch
rm Makefile-orig

#echo "Reducing the number of consoles"
#if [ "$kernel_branch" -ge 12 ]; then
 #if [[ "${kernel_version%%.*}" -ge 3 -a "$kernel_branch" -ge 16 ]]; then
	 cp kernel/printk/printk.c kernel/printk/printk.c.orig
	 sed -i s/'#define MAX_CMDLINECONSOLES 8'/'#define MAX_CMDLINECONSOLES 5'/ kernel/printk/printk.c
	 diff -up kernel/printk/printk.c.orig kernel/printk/printk.c > ../dist/sources/patches/less-consoles.patch
	
	 echo "Reducing the verbosity level"
	 cp -f include/linux/printk.h include/linux/printk.h.orig
	 sed -i s/'#define CONSOLE_LOGLEVEL_DEFAULT 7 \/\* anything MORE serious than KERN_DEBUG \*\/'/'#define CONSOLE_LOGLEVEL_DEFAULT 3 \/\* anything MORE serious than KERN_ERR \*\/'/ include/linux/printk.h
	 diff -up include/linux/printk.h.orig include/linux/printk.h > ../dist/sources/patches/lower-verbosity.patch


#patches () {
for patch in ../patches/*; do
	echo "Applying $patch"
	patch -p1 < $patch >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to apply $patch on the kernel sources."
		exit 1
	fi
	cp $patch ../dist/sources/patches

done
#}
#patches

#cleaningsrc () {
echo "Cleaning the kernel sources"
if [[ -z "$DEB" ]]; then
make clean
make mrproper
else
make-kpkg clean
fi
find . -name '*.orig' -delete
find . -name '*.rej' -delete
find . -name '*~' -delete

cd linux-$kernel_version
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/i386_defconfig
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/x86_64_defconfig

#pause to configure
#configure () {
clear
echo -e "For unattended config of new kernels do nothing here!
For old kernel versions or other customisations enter 2 ... 

1. make olddefconfig
2. make menuconfig $timelimit seconds\n: \c"
echo
read -t $timelimit kernelconfig
if [ ! -z "$kernelconfig" ]; then
echo -e "\n You entered '$kernelconfig'"
else
echo -e "\n TIME OUT\n Assume default."
kernelconfig=1
fi

case $kernelconfig in
1) make olddefconfig;;
2) make menuconfig;;
esac

echo
echo "Ok, kernel is configured. CTRL+C to quit"
sleep 2
if [  "$kernelconfig" = 1 ]; then
cp -f ../DOTconfig .config.old
cp -f ../DOTconfig .config
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/i386_defconfig
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/x86_64_defconfig
fi


[ ! -d ../dist/packages ] && mkdir -p ../dist/packages
#}
#configure
#krnheads () {
	echo "Creating the kernel headers package"
make headers_check >> ../build.log 2>&1
make INSTALL_HDR_PATH=kernel_headers-$kernel_major_version-$package_name_suffix/usr headers_install >> ../build.log 2>&1
find kernel_headers-$kernel_major_version-$package_name_suffix/usr/include \( -name .install -o -name ..install.cmd \) -delete
mv kernel_headers-$kernel_major_version-$package_name_suffix ../dist/packages
#}
#krnheads

#krncompile () {
echo "Compiling the kernel"
cores=`cat /proc/cpuinfo | grep 'cpu cores' | cut -f3 -d ' ' | tr '\n' ' ' | cut -f1 -d ' '`
if [ "$cores" -ge 2 ]; then
	if [[ -z "$DEB" ]]; then
	make -j6
	elif [[ ! -z "$DEB" ]]; then
	fakeroot make-kpkg --initrd --revision=custom.emsee-$tmstamp kernel_image -j6
	fi
else
	if [[ -z "$DEB" ]]; then
	make
	elif [[ ! -z "$DEB" ]]; then
	fakeroot make-kpkg --initrd --revision=custom.emsee-$tmstamp kernel_image
	fi
fi
if [[ ! -f arch/x86/boot/bzImage || ! -f System.map ]]; then
	echo "Error: failed to compile the kernel sources."
	exit 1
fi
cp .config ../dist/sources/DOTconfig-$kernel_version-$tmstamp

#}

#krncompile
echo "Creating the kernel package"
make INSTALL_MOD_PATH=linux_kernel-$kernel_major_version-$package_name_suffix modules_install >> ../build.log 2>&1
rm -f linux_kernel-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/{build,source}
mkdir -p linux_kernel-$kernel_major_version-$package_name_suffix/boot
mkdir -p linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules
cp .config linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules/DOTconfig-$kernel_version-
cp arch/x86/boot/bzImage linux_kernel-$kernel_major_version-$package_name_suffix/boot/vmlinuz
BZIMAGE=`find . -type f -name bzImage`
cp System.map linux_kernel-$kernel_major_version-$package_name_suffix/boot/
cp linux_kernel-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/{modules.builtin,modules.order} \
 linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules/
mv linux_kernel-$kernel_major_version-$package_name_suffix ../dist/packages/
if [ "$FD" = "1" ];then #make fatdog kernel module package
	mv ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/vmlinuz ../dist/packages/vmlinuz
	[ -f ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/bzImage ] &&
rm -f ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/bzImage
	echo "Huge kernel $kernel_major_version-$package_name_suffix is ready in dist"
fi
echo "Cleaning the kernel sources"
make clean >> ../build.log 2>&1
make prepare >> ../build.log 2>&1

cd ..

# build aufs-utils userspace modules
echo "Now to build the aufs-utils for userspace"
if [ ! -f dist/sources/vanilla/aufs-util${today}.tar.bz2 ];then
	git clone git://aufs.git.sourceforge.net/gitroot/aufs/aufs-util.git aufs-util >> build.log 2>&1
	[[ $? -ne 0 ]] && echo "Failed to get aufs-util from git, do it manually. Kernel is compiled OK :)" && exit
	
	cd aufs-util
	
	git branch -a | grep 'aufs3' |grep -v 'rcN' | cut -d '.' -f2 > /tmp/aufs-util-version #we go for stable only
	while read line
	  do 
	    if [[ "$kernel_branch" = "$line" ]];then branch=$line
	    else
	      while [[ "$kernel_branch" -gt "$line" ]]
	        do branch=$line
	        echo $branch && break
	        done 
	    fi
	  done < /tmp/aufs-util-version
	git checkout origin/aufs3.${branch} >> ../build.log 2>&1
	
	[[ $? -ne 0 ]] && echo "Failed to get aufs-util from git, do it manually. Kernel is compiled OK :)" && exit
	echo "Patching aufs-util sources"
	cp Makefile Makefile.orig
	sed -i 's/-static //' Makefile
	diff -ru Makefile.orig Makefile > ../dist/sources/patches/aufs-util-dynamic.patch
	rm *.orig
	else
	echo "Extracting the Aufs-util sources"
	tar xf dist/sources/vanilla/aufs-util$today.tar.bz2 >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to extract the aufs-util sources."
		exit 1
	fi	
	cd aufs-util	
	patch -p1 < ../dist/sources/patches/aufs-util-dynamic.patch >> ../build.log 2>&1
	[[ "$?" -ne 0 ]] && echo "Failed to patch the aufs-util sources, do it manually. Kernel is compiled ok"
fi
arch=`uname -m`
CONFIG=`find $CWD/dist/sources -type f -name 'DOTconfig*'`
grep -q 'CONFIG_AUFS_FHSM=y' $CONFIG
[[ "$?" -eq 0 ]] && export MAKE=make || export MAKE="make BuildFHSM=no"
LinuxSrc=`find $CWD -type d -name 'kernel_headers*'`
export CPPFLAGS="-I $LinuxSrc/usr/include"
$MAKE >> ../build.log 2>&1
[[ $? -ne 0 ]] && echo "Failed to compile aufs-util, do it manually. Kernel is compiled OK :)"
make DESTDIR=$CWD/dist/packages/aufs-util-$kernel_version-$arch install >> ../build.log 2>&1 #maybe needs absolute path
make clean >> ../build.log 2>&1
if [[ "$arch" = "x86_64" ]];then
 mv $CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib \
$CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib64
fi
echo "aufs-util-$kernel_version is in dist"
cd ..
if [[ "$FD" = "1" ]];then #shift aufs-utils to kernel-modules.sfs
	echo "Installing aufs-utils into kernel package"
	cp -a dist/packages/aufs-util-$kernel_version-$arch/* \
	dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix
	cp -r /lib/firmware dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/lib/
	mksquashfs dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix dist/packages/kernel-modules-$kernel_major_version-$package_name_suffix.sfs $COMP

fi

#tar -c aufs-util | bzip2 -9 > dist/sources/vanilla/aufs-util$today-$-$arch.tar.bz2


echo "Done!"

rename packages packages32-nopae dist/packages



[ -f /usr/share/sounds/2barks.au ] && aplay /usr/share/sounds/2barks.au

}

#THIRD RUN
bldkern3 () {
. build32-pae.conf

if [ "$1" = "" ];then
	echo -en "\033[1;35m""WARNING" #purple?
	echo -en "\033[0m" #reset
	echo ": This will delete aufs, kernel folder but wont touch configs or dist."
	sleep 2
	echo "Please wait..."
	rm -rf ./{aufs*,build.log*}
	echo "Cleaning complete"
fi
if [[ -d ./aufs* ]];then
	echo "This is not a clean kit."
	echo " CTRL+C to quit"
	read notcleango
fi

FW_URL=${FW_URL:-http://distro.ibiblio.org/puppylinux/firmware}
package_name_suffix=$package_name_suffix
custom_suffix=$custom_suffix
kernel_version=$kernel_version
kernel_mirror=$kernel_mirror
# the aufs major version
aufs_version=${kernel_version%%.*}
# get the major version (2.6.32 in the case of 2.6.32.40)
kernel_major_version=$kernel_version #blah, hack for 3.x
# get the kernel branch (32 in the case of 2.6.32.40; needed to download Aufs)
kernel_branch=`echo $kernel_major_version | cut -f 2 -d .` #3.x kernels

# create directories for the results
[ ! -d dist/sources/vanilla ] && mkdir -p dist/sources/{patches,vanilla}


# .configs
[ -f /tmp/kernel_configs ] && rm -f /tmp/kernel_configs

CONFIGS=$(ls ./configs_extra)

# list
echo "configs"
NUM=1
for C in $CONFIGS
  do echo "${NUM}. $C" >> /tmp/kernel_configs
  NUM=$(($NUM + 1))
  done
#echo "z. Custom DOTconfig" >> /tmp/kernel_configs
#echo "d. Default DOTconfig" >> /tmp/kernel_configs  
figs=`cat /tmp/kernel_configs`
echo "$figs"
sleep 2

Chosen=3

echo "$Chosen"
sleep 1
Choice=$(grep "^$Chosen\." /tmp/kernel_configs | cut -d ' ' -f2)
echo "$Choice"
sleep 1
[[ DOTconfig ]] && rm -r DOTconfig
cp -af configs_extra/$Choice DOTconfig

# download the kernel
echo ${kernel_version##*-}|grep -q "rc"
[ "$?" -eq 0 ] && testing=testing||testing=
	if [[ ! -f dist/sources/vanilla/linux-$kernel_version.tar.xz ]]; then
	echo "Downloading the kernel sources"
	wget -P dist/sources/vanilla $kernel_mirror/$testing/linux-$kernel_version.tar.xz --no-check-certificate > build.log 2>&1
		if [[ $? -ne 0 ]]; then
			echo "Error: failed to download the kernel sources."
			exit 1
		fi
elif [ -f dist/sources/vanilla/linux-$kernel_version.tar.xz ]; then
echo "Kernel Sources already there!"
fi
#}

#downkern

#downaufs () {
	# download Aufs
#if [ ! -f dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2 ]; then

		git clone git://git.code.sf.net/p/aufs/aufs3-standalone aufs$aufs_version-18-git$today >> build.log 2>&1

		if [[ $? -ne 0 ]]; then
			echo "Error: failed to download the Aufs sources."
			exit 1
		fi
#fi
		cd aufs$aufs_version-$kernel_branch-git$today
		if [[ "$aufsv" ]];then #new far for new kernels
		git checkout origin/aufs$aufsv >> ../build.log 2>&1
		else
		git checkout origin/aufs$aufs_version.$kernel_branch >> ../build.log 2>&1
		fi
		if [[ $? -ne 0 ]]; then
		echo "Error: failed to download the Aufs sources."
		exit 1
		fi
	rm -rf .git
	cd ..
	echo "Creating the Aufs sources tarball"
	tar -c aufs$aufs_version-$kernel_branch-git$today | bzip2 -9 > dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2

	echo "Extracting the Aufs sources"
	tar xf dist/sources/vanilla/aufs$aufs_version-$kernel_branch-git$today.tar.bz2
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to extract the Aufs sources."
		exit 1
		fi
#}
#downaufs

#patchaufs () {
	# patch Aufs
if [ -f aufs-allow-sfs.patch ];then #removed for K3.9 experiment
	echo "Patching the Aufs sources"
	patch -d aufs$aufs_version-$kernel_branch-git$today -p1 < aufs-allow-sfs.patch >> build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to patch the Aufs sources."
		exit 1
	fi
	cp aufs-allow-sfs.patch dist/sources/patches
fi
if [ -f aufs-kconfig.patch ];then #special for K3.9
	echo "Patching the Aufs sources"
	patch -d aufs$aufs_version-$kernel_branch-git$today -p1 < aufs-kconfig.patch >> build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to patch the Aufs sources for kconfig."
		exit 1
	fi
	cp aufs-kconfig.patch dist/sources/patches
fi
#}
#patchaufs

#extractkern () {
	# extract the kernel
echo "Extracting the kernel sources"
tar xf dist/sources/vanilla/linux-$kernel_version.tar.* >> build.log 2>&1
if [[ $? -ne 0 ]]; then
	echo "Error: failed to extract the kernel sources."
	exit 1
	extractkern
else
echo "extracted"
fi
#}
#extractkern

cd linux-$kernel_version

#aufspatch () {
	echo "Adding Aufs to the kernel sources"
for i in kbuild base standalone mmap; do
	patch -N -p1 < ../aufs$aufs_version-$kernel_branch-git$today/aufs$aufs_version-$i.patch >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "WARNING: failed to add some Aufs patches to the kernel sources."
		echo "Check it manually and either CRTL+C to bail or hit enter to go on"
		sleep 4
	fi
done
#}
#aufspatch

cp -r ../aufs$aufs_version-$kernel_branch-git$today/{fs,Documentation} .
cp ../aufs$aufs_version-$kernel_branch-git$today/include/linux/aufs_type.h include/linux 2>/dev/null
cp ../aufs$aufs_version-$kernel_branch-git$today/include/uapi/linux/aufs_type.h include/linux 2>/dev/null
[ -d ../aufs$aufs_version-$kernel_branch-git$today/include/uapi ] && \
cp -r ../aufs$aufs_version-$kernel_branch-git$today/include/uapi/linux/aufs_type.h include/uapi/linux

echo "Resetting the minor version number"
cp Makefile Makefile-orig
sed -i "s/^EXTRAVERSION =/EXTRAVERSION = $custom_suffix/" Makefile
diff -up Makefile-orig Makefile > ../dist/sources/patches/extra-version.patch
rm Makefile-orig

#echo "Reducing the number of consoles"
#if [ "$kernel_branch" -ge 12 ]; then
 #if [[ "${kernel_version%%.*}" -ge 3 -a "$kernel_branch" -ge 16 ]]; then
	 cp kernel/printk/printk.c kernel/printk/printk.c.orig
	 sed -i s/'#define MAX_CMDLINECONSOLES 8'/'#define MAX_CMDLINECONSOLES 5'/ kernel/printk/printk.c
	 diff -up kernel/printk/printk.c.orig kernel/printk/printk.c > ../dist/sources/patches/less-consoles.patch
	
	 echo "Reducing the verbosity level"
	 cp -f include/linux/printk.h include/linux/printk.h.orig
	 sed -i s/'#define CONSOLE_LOGLEVEL_DEFAULT 7 \/\* anything MORE serious than KERN_DEBUG \*\/'/'#define CONSOLE_LOGLEVEL_DEFAULT 3 \/\* anything MORE serious than KERN_ERR \*\/'/ include/linux/printk.h
	 diff -up include/linux/printk.h.orig include/linux/printk.h > ../dist/sources/patches/lower-verbosity.patch


#patches () {
for patch in ../patches/*; do
	echo "Applying $patch"
	patch -p1 < $patch >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to apply $patch on the kernel sources."
		exit 1
	fi
	cp $patch ../dist/sources/patches

done
#}
#patches

#cleaningsrc () {
echo "Cleaning the kernel sources"
if [[ -z "$DEB" ]]; then
make clean
make mrproper
else
make-kpkg clean
fi
find . -name '*.orig' -delete
find . -name '*.rej' -delete
find . -name '*~' -delete

cd linux-$kernel_version
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/x86_64_defconfig

cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/i386_defconfig

#pause to configure
#configure () {
clear
echo -e "For unattended config of new kernels do nothing here!
For old kernel versions or other customisations enter 2 ... 

1. make olddefconfig
2. make menuconfig $timelimit seconds\n: \c"
echo
read -t $timelimit kernelconfig
if [ ! -z "$kernelconfig" ]; then
echo -e "\n You entered '$kernelconfig'"
else
echo -e "\n TIME OUT\n Assume default."
kernelconfig=1
fi

case $kernelconfig in
1) make olddefconfig;;
2) make menuconfig;;
esac

echo
echo "Ok, kernel is configured. CTRL+C to quit"
sleep 2
if [  "$kernelconfig" = 1 ]; then
cp -f ../DOTconfig .config.old
cp -f ../DOTconfig .config
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/i386_defconfig
cp -f ../DOTconfig ../kernel_sources-${kernel_major_version}-$package_name_suffix/arch/x86/configs/x86_64_defconfig
fi

[ ! -d ../dist/packages ] && mkdir -p ../dist/packages
#}
#configure
#krnheads () {
	echo "Creating the kernel headers package"
make headers_check >> ../build.log 2>&1
make INSTALL_HDR_PATH=kernel_headers-$kernel_major_version-$package_name_suffix/usr headers_install >> ../build.log 2>&1
find kernel_headers-$kernel_major_version-$package_name_suffix/usr/include \( -name .install -o -name ..install.cmd \) -delete
mv kernel_headers-$kernel_major_version-$package_name_suffix ../dist/packages
#}
#krnheads

#krncompile () {
echo "Compiling the kernel"
cores=`cat /proc/cpuinfo | grep 'cpu cores' | cut -f3 -d ' ' | tr '\n' ' ' | cut -f1 -d ' '`
if [ "$cores" -ge 2 ]; then
	if [[ -z "$DEB" ]]; then
	make -j6
	elif [[ ! -z "$DEB" ]]; then
	fakeroot make-kpkg --initrd --revision=custom.emsee-$tmstamp kernel_image -j6
	fi
else
	if [[ -z "$DEB" ]]; then
	make
	elif [[ ! -z "$DEB" ]]; then
	fakeroot make-kpkg --initrd --revision=custom.emsee-$tmstamp kernel_image
	fi
fi
if [[ ! -f arch/x86/boot/bzImage || ! -f System.map ]]; then
	echo "Error: failed to compile the kernel sources."
	exit 1
fi
cp .config ../dist/sources/DOTconfig-$kernel_version-$tmstamp

#}

#krncompile
echo "Creating the kernel package"
make INSTALL_MOD_PATH=linux_kernel-$kernel_major_version-$package_name_suffix modules_install >> ../build.log 2>&1
rm -f linux_kernel-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/{build,source}
mkdir -p linux_kernel-$kernel_major_version-$package_name_suffix/boot
mkdir -p linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules
cp .config linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules/DOTconfig-$kernel_version-
cp arch/x86/boot/bzImage linux_kernel-$kernel_major_version-$package_name_suffix/boot/vmlinuz
BZIMAGE=`find . -type f -name bzImage`
cp System.map linux_kernel-$kernel_major_version-$package_name_suffix/boot/
cp linux_kernel-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/{modules.builtin,modules.order} \
 linux_kernel-$kernel_major_version-$package_name_suffix/etc/modules/
mv linux_kernel-$kernel_major_version-$package_name_suffix ../dist/packages/
if [ "$FD" = "1" ];then #make fatdog kernel module package
	mv ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/vmlinuz ../dist/packages/vmlinuz
	[ -f ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/bzImage ] &&
rm -f ../dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/boot/bzImage
	echo "Huge kernel $kernel_major_version-$package_name_suffix is ready in dist"
fi
echo "Cleaning the kernel sources"
make clean >> ../build.log 2>&1
make prepare >> ../build.log 2>&1

cd ..

echo "Creating a kernel sources SFS"
mkdir -p kernel_sources-$kernel_major_version-$package_name_suffix/usr/src
mv linux-$kernel_version kernel_sources-$kernel_major_version-$package_name_suffix/usr/src/linux
mkdir -p kernel_sources-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix
ln -s /usr/src/linux kernel_sources-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/build
[ ! -f kernel_sources-${kernel_major_version}-$package_name_suffix/usr/src/linux/include/linux/version.h ] && \
ln -s /usr/src/linux/include/generated/uapi/linux/version.h kernel_sources-${kernel_major_version}-$package_name_suffix/usr/src/linux/include/linux/version.h 
ln -s /usr/src/linux kernel_sources-$kernel_major_version-$package_name_suffix/lib/modules/${kernel_major_version}$custom_suffix/source
mksquashfs kernel_sources-$kernel_major_version-$package_name_suffix dist/sources/kernel_sources-$kernel_major_version-$package_name_suffix.sfs $COMP

# build aufs-utils userspace modules
echo "Now to build the aufs-utils for userspace"
if [ ! -f dist/sources/vanilla/aufs-util${today}.tar.bz2 ];then
	git clone git://aufs.git.sourceforge.net/gitroot/aufs/aufs-util.git aufs-util >> build.log 2>&1
	[[ $? -ne 0 ]] && echo "Failed to get aufs-util from git, do it manually. Kernel is compiled OK :)" && exit
	
	cd aufs-util
	
	git branch -a | grep 'aufs3' |grep -v 'rcN' | cut -d '.' -f2 > /tmp/aufs-util-version #we go for stable only
	while read line
	  do 
	    if [[ "$kernel_branch" = "$line" ]];then branch=$line
	    else
	      while [[ "$kernel_branch" -gt "$line" ]]
	        do branch=$line
	        echo $branch && break
	        done 
	    fi
	  done < /tmp/aufs-util-version
	git checkout origin/aufs3.${branch} >> ../build.log 2>&1
	
	[[ $? -ne 0 ]] && echo "Failed to get aufs-util from git, do it manually. Kernel is compiled OK :)" && exit
	echo "Patching aufs-util sources"
	cp Makefile Makefile.orig
	sed -i 's/-static //' Makefile
	diff -ru Makefile.orig Makefile > ../dist/sources/patches/aufs-util-dynamic.patch
	rm *.orig
	else
	echo "Extracting the Aufs-util sources"
	tar xf dist/sources/vanilla/aufs-util$today.tar.bz2 >> ../build.log 2>&1
	if [[ $? -ne 0 ]]; then
		echo "Error: failed to extract the aufs-util sources."
		exit 1
	fi	
	cd aufs-util	
	patch -p1 < ../dist/sources/patches/aufs-util-dynamic.patch >> ../build.log 2>&1
	[[ "$?" -ne 0 ]] && echo "Failed to patch the aufs-util sources, do it manually. Kernel is compiled ok"
fi
arch=`uname -m`
CONFIG=`find $CWD/dist/sources -type f -name 'DOTconfig*'`
grep -q 'CONFIG_AUFS_FHSM=y' $CONFIG
[[ "$?" -eq 0 ]] && export MAKE=make || export MAKE="make BuildFHSM=no"
LinuxSrc=`find $CWD -type d -name 'kernel_headers*'`
export CPPFLAGS="-I $LinuxSrc/usr/include"
$MAKE >> ../build.log 2>&1
[[ $? -ne 0 ]] && echo "Failed to compile aufs-util, do it manually. Kernel is compiled OK :)"
make DESTDIR=$CWD/dist/packages/aufs-util-$kernel_version-$arch install >> ../build.log 2>&1 #maybe needs absolute path
make clean >> ../build.log 2>&1
if [[ "$arch" = "x86_64" ]];then
 mv $CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib \
$CWD/dist/packages/aufs-util-$kernel_version-$arch/usr/lib64
fi
echo "aufs-util-$kernel_version is in dist"
cd ..
if [[ "$FD" = "1" ]];then #shift aufs-utils to kernel-modules.sfs
	echo "Installing aufs-utils into kernel package"
	cp -a dist/packages/aufs-util-$kernel_version-$arch/* \
	dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix
	cp -r /lib/firmware dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix/lib/
	mksquashfs dist/packages/linux_kernel-$kernel_major_version-$package_name_suffix dist/packages/kernel-modules-$kernel_major_version-$package_name_suffix.sfs $COMP
	#[[ "$?" = 0 ]] && echo "Huge compatible kernel packages are ready to package./" || exit 1
	echo "Packaging huge-$kernel_major_version-$package_name_suffix kernel"
	cd dist/packages/
	tar -cjvf huge-$kernel_major_version-${package_name_suffix}.tar.bz2 \
	vmlinuz kernel-modules-$kernel_major_version-$package_name_suffix.sfs
	#[[ "$?" = 0 ]] && echo "huge-$kernel_major_version-${package_name_suffix}.tar.bz2 is in dist/packages" || exit 1
	md5sum huge-$kernel_major_version-${package_name_suffix}.tar.bz2 > huge-$kernel_major_version-${package_name_suffix}.tar.bz2.md5.txt
	#echo
	cd $CWD
fi

#tar -c aufs-util | bzip2 -9 > dist/sources/vanilla/aufs-util$today-$-$arch.tar.bz2


echo "Done!"

rename packages packages32-pae dist/packages

[ -f /usr/share/sounds/2barks.au ] && aplay /usr/share/sounds/2barks.au

}

case $arch in
1) bldkern1;;
2) bldkern2;;
3) bldkern3;;
12) bldkern1
bldkern2;;
13) bldkern1
bldkern2;;
23) bldkern2
bldkern3;;
123) bldkern1
bldkern2
bldkern3;;
esac
mkkernsrc
echo "Compilation has finished.  Exiting script."
exit
###the end###
